# Stage 1: Build stage
FROM node:21 AS builder

WORKDIR /app

# Clone the repository
RUN git clone https://gitlab.com/anupam.dutta753/devops-fullstack-app.git

# Change to the frontend directory
WORKDIR /app/devops-fullstack-app/frontend

# Install dependencies
#RUN npm install

# Update npm
RUN npm install -g npm --no-cache

# Update browserslist-db
RUN npx update-browserslist-db@latest

# Build the application
RUN npm run build

# Stage 2: Nginx stage
FROM nginx:alpine

# Copy built files from the previous stage
COPY --from=builder /app/devops-fullstack-app/frontend/build /usr/share/nginx/html

# Create a new Nginx configuration
RUN echo "server {" > /etc/nginx/conf.d/default.conf && \
    echo "    listen 80;" >> /etc/nginx/conf.d/default.conf && \
    echo "    location / {" >> /etc/nginx/conf.d/default.conf && \
    echo "        root   /usr/share/nginx/html;" >> /etc/nginx/conf.d/default.conf && \
    echo "        index  index.html index.htm;" >> /etc/nginx/conf.d/default.conf && \
    echo "        try_files \$uri \$uri/ /index.html;" >> /etc/nginx/conf.d/default.conf && \
    echo "    }" >> /etc/nginx/conf.d/default.conf && \
    echo "}" >> /etc/nginx/conf.d/default.conf

# Expose port 80
EXPOSE 80

# Command to run Nginx
CMD ["nginx", "-g", "daemon off;"]
